package pro.litvinovg.docsettings;

import java.util.HashMap;
import java.util.prefs.BackingStoreException;
import java.util.prefs.Preferences;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class ExtensionConfig {

	private static final Logger logger = LoggerFactory.getLogger(ExtensionConfig.class);
	private static final String AUTO_RESTORE = "autoRestore";
	private static ExtensionConfig extensionSettings = null;
	private Preferences storage;

	public static ExtensionConfig getInstance() {
		if (extensionSettings != null) {
			return extensionSettings;
		}
		extensionSettings = new ExtensionConfig();
		return extensionSettings;
	}

	private ExtensionConfig() {
		storage = Preferences.userRoot().node(this.getClass().getName());
	}

	public boolean getAutoRestore() {
		return storage.getBoolean(AUTO_RESTORE, false);
	}

	public void setAutoRestore(boolean value) {
		storage.putBoolean(AUTO_RESTORE, value);
		try {
			storage.sync();
		} catch (BackingStoreException e) {
			logger.debug("Ops", e);
		}
	}
}
