package pro.litvinovg.docsettings.settings;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.w3c.dom.Node;

import pro.litvinovg.docsettings.exceptions.MalformedXmlException;

import static pro.litvinovg.docsettings.settings.StorageUtils.*;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;
import java.util.TreeMap;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathConstants;
import javax.xml.xpath.XPathExpression;
import javax.xml.xpath.XPathExpressionException;
import javax.xml.xpath.XPathFactory;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import pro.litvinovg.docsettings.exceptions.MalformedXmlException;

public class SettingFactory {
	private static final String TYPE_INT = "int";
	private static final String TYPE_BASE64_BINARY = "base64Binary";
	private static final String TYPE_STRING = "string";
	private static final String TYPE_SHORT = "short";
	private static final String TYPE_BOOLEAN = "boolean";
	private static final Logger logger = LoggerFactory.getLogger(SettingFactory.class);

	public static ODFSetting create(Node node) throws MalformedXmlException {
		 Node typeNode = node.getAttributes().getNamedItem("config:type");
		 if (typeNode == null) {
			 logger.debug("nodeType is null");
			 throw new MalformedXmlException("Node " + node.getNodeName() + " config:type attribute not found.");
		 }
		 String type = typeNode.getNodeValue();
		 if (type == null || type.isEmpty()) {
			 logger.debug("node type value is null or empty");
			 throw new MalformedXmlException("Node " + node.getNodeName() + " config:type attribute not found.");
		 }
		 if (TYPE_BOOLEAN.equals(type)||
				 TYPE_SHORT.equals(type)|| 
			 	 TYPE_STRING.equals(type)||
			 	 TYPE_BASE64_BINARY.equals(type)||
			 	 TYPE_INT.equals(type)) {
			 return new SimpleSetting(node);
		 } 
		 logger.debug("node type not recognized");
		 throw new MalformedXmlException("Node " + node.getNodeName());
	}
}
