package pro.litvinovg.docsettings.settings;

import static pro.litvinovg.docsettings.settings.StorageUtils.*;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

public class Settings {
	private static final Logger logger = LoggerFactory.getLogger(Settings.class);


	private List<ODFSetting> settings = null;
		
	public Settings() {
		this.settings = new ArrayList<ODFSetting>();
	}
	
	public void add(ODFSetting setting) {
		settings.add(setting);
	}
	
	public void remove(int index) {
		settings.remove(index);
	}
	
	public void remove(ODFSetting setting) {
		settings.remove(setting);
	}
	
	public int getSize() {
		return settings.size();
	}
	
	public ODFSetting get(int num) {
		return settings.get(num);
	}
	
	public ODFSetting getByName(String name) {
		for (Iterator iterator = settings.iterator(); iterator.hasNext();) {
			ODFSetting odfSetting = (ODFSetting) iterator.next();
			if (name.equals(odfSetting.getName())) {
				return odfSetting;
			}
		}
		return null;
	}
	
	public void clear() {
		settings.clear();
	}
	
	public boolean isEmpty() {
		return settings.isEmpty();
	}

	public String toSettingsContent(String content) throws Exception {
		Document doc = getDocFromString(content);
		Node settingsContainer = getSettingsElement(doc);
		NodeList settingNodes = settingsContainer.getChildNodes();
		removeNodes(settingNodes);
		appendSettingNodesToDoc(this, doc, settingsContainer);
		String newSettingsContent = serializeDoc(doc);
		return newSettingsContent;
	}

	public void addAll(Settings inputSettings) {
		for (int i = 0; i < inputSettings.getSize(); i++) {
			this.add(inputSettings.get(i));
		}
	}
}
